#ifndef CLASSIFIER__H
#define CLASSIFIER__H

#include <string>
#include "TransitionSet.hpp"
#include "NeuralNetwork.hpp"

class Classifier
{
  private :

  std::string name;
  std::unique_ptr<TransitionSet> transitionSet;
  std::shared_ptr<NeuralNetworkImpl> nn;

  private :

  void initNeuralNetwork(const std::string & topology);

  public :

  Classifier(const std::string & name, const std::string & topology, const std::string & tsFile);
  TransitionSet & getTransitionSet();
  NeuralNetwork & getNN();
  const std::string & getName() const;
};

#endif
